package ms.warpzone.warppay.dialogs;

import android.app.Dialog;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.GridLayout;

import java.util.List;

import ms.warpzone.warppay.MainActivity;
import ms.warpzone.warppay.R;
import ms.warpzone.warppay.data.models.local.Product;
import ms.warpzone.warppay.manager.MainManager;
import ms.warpzone.warppay.manager.UiManager;
import ms.warpzone.warppay.orderList.Order;

public class ProductDialog extends Dialog implements View.OnClickListener {
    private MainActivity c;
    public Dialog d;
    public GridLayout gridProducts;
    private String category;
    public ProductDialog(String category) {
        super(MainManager.getInstance().getMainActivity());
        c = MainManager.getInstance().getMainActivity();
        this.category = category;

    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.product_dialog);

        this.gridProducts = (GridLayout) findViewById(R.id.gridProductDialog);
        this.gridProducts.setMinimumWidth(300);
        this.gridProducts.setMinimumHeight(200);
        this.gridProducts.removeAllViews();
        List<Product> products= Product.getByCategory(this.category);
        for (Product p: products) {
            Button prodButton = new Button(this.c.getApplicationContext());
            prodButton.setHeight(200);
            prodButton.setWidth(200);
            prodButton.setGravity(0);
            prodButton.setText(p.getName());
            prodButton.setOnClickListener(this);
            this.gridProducts.addView(prodButton);
        }
        for (int i=products.size();i<15;i++) {
            Button btn = new Button(this.c.getApplicationContext());
            btn.setHeight(200);
            btn.setWidth(200);
            btn.setGravity(0);
            btn.setText("");
            btn.setEnabled(false);
            this.gridProducts.addView(btn);
        }
    }


    @Override
    public void onClick(View view) {
        MainManager.getInstance().startTimer();
        Button clicked = (Button) view;
        String product_name = (String) clicked.getText();
        Product product = Product.getOneByName(product_name);
        Order order = new Order(product);
        UiManager.getInstance().addOrder(order);
        MainManager.getInstance().addOrder(order);
        dismiss();
    }
}
